type SaskType = record
                      Con:longint;
                      V:array['a'..'h'] of integer;
                end;

var Vert:array['a'..'h'] of longint;
    S:string;
    Sask:array[1..20] of SaskType;
    n:integer;

procedure ReadInput;
var filename:string; ch,ch1:char;
begin
     Write('Input filename: '); ReadLn(filename);
     Assign(input,filename); Reset(input);
     ReadLn(S);
     for ch:='a' to 'h' do Vert[ch]:=MaxLongInt;
     while not Eof(input) do ReadLn(ch,ch1,Vert[ch]);
     Close(input);
end;

procedure MakeSask;
var q,t:string; sk:longint; Code:integer;
begin
     if not (S[1] in ['-','+']) then S:='+'+S;
     n:=0;
     while S<>'' do
           begin
                Inc(n); FillChar(Sask[n],SizeOf(SaskType),0);
                with Sask[n] do
                     begin
                          if S[1]='-' then Con:=-1 else Con:=1;
                          Delete(S,1,1);
                          q:='';
                          while (S<>'') and not (S[1] in ['-','+']) do
                                begin q:=q+S[1]; Delete(S,1,1); end;
                          while q<>'' do
                                if q[1] in ['a'..'h'] then
                                   begin Inc(V[q[1]]); Delete(q,1,1); end
                                else begin
                                          t:='';
                                          while (q<>'') and (q[1] in ['0'..'9']) do
                                                begin
                                                     t:=t+q[1]; Delete(q,1,1);
                                                end;
                                          Val(t,sk,Code);
                                          Con:=Con*sk;
                                     end;
                     end;
           end;
end;

function Vien(i,j:integer):boolean;
var ch:char;
begin
     for ch:='a' to 'h' do
         if Sask[i].V[ch]<>Sask[j].V[ch] then
            begin Vien:=False; Exit; end;
     Vien:=True;
end;

procedure Normalize;
var i,j,k:integer; ch:char;
begin
     for i:=1 to n do
         with Sask[i] do
              for ch:='a' to 'h' do
                  if Vert[ch]<>MaxLongInt then
                     while V[ch]<>0 do
                           begin Con:=Con*Vert[ch]; Dec(V[ch]); end;
     i:=1;
     while i<=n do
           begin
                j:=i+1;
                while j<=n do
                      if Vien(i,j) then
                         begin
                              Inc(Sask[i].Con,Sask[j].Con);
                              for k:=j to n-1 do Sask[k]:=Sask[k+1];
                              Dec(n);
                         end
                      else Inc(j);
                Inc(i);
           end;
end;

procedure Aprekina;
var Sum:longint; i:integer; ch:char;
begin
     Sum:=0;
     for i:=1 to n do
         with Sask[i] do
              if Con<>0 then
                 begin
                      for ch:='a' to 'h' do
                          if V[ch]<>0 then
                             begin WriteLn('UNDEFINED'); Exit; end;
                      Inc(Sum,Con);
                 end;
     WriteLn(Sum);
end;

begin
     ReadInput;
     MakeSask;
     Normalize;
     Assign(output,'output.txt'); Rewrite(output);
     Aprekina;
     Close(output);
end.