program senas_hronikas;

{Tiek ievadta informcija kd no sekojoiem formtiem :
    id_1>id_2  (id_1 ir vecks par id_2)
    id_1<id_2  (id_1 ir jaunks par id_2)
    id_1=id_2  (id_1 ir tikpat vecs cik id_2)

    Pc visas pieejams informcijas saemanas jsniedz atbildes par dadu personu pru vecumu
}

{$IFDEF WINDOWS} uses WinCrt; {$ENDIF}

const
 max_id = 500;
 max_lo = (max_id+31) div 32;
 zime : array [0..3] of char = ('?','>','<','=');

type
 rinda = array [1..max_lo] of longint;
 koord = record
          longs : byte; {longs, kur ir}
          maska : longint;
         end;

var
  ida : array [1..max_id] of string[2];
    a : array [1..max_id] of rinda;    {a[i] glabjas zias par tiem, kas ir jaunki vai viendi ar i}
 koordmas : array[1..max_id] of koord;
  i,j,cik_tagad_ir,ind1,ind2,n,nn : integer;
 flag : boolean;
 f_in, f_rez : Text;
 koord_ir : koord;
 pazime : byte;

 procedure Ielasi_rindu(var i1,i2 : integer; var fl:boolean);
 {Ielasa krtjo rindu pc formta :
   <id_2_simboli><zme><id_2_simboli>}
 var s_id : array [1..2] of string[2];
     zime : string[1];
     i,j : integer;
     id : array [1..2] of integer;
     atrasts : boolean;
  begin
   Readln(f_in,s_id[1],zime,s_id[2]);

   {Mekl atbilstoo identifikatoru sarakst}
   for j:=1 to 2 do
    BEGIN
     atrasts := false;
     for i:=1 to cik_tagad_ir do
      if s_id[j]=ida[i]
       then
        begin
         id[j]:=i;
         atrasts := true;
        end;
     if not atrasts
      then {jaizpilda informcija par jauno}
       begin
        Inc(cik_tagad_ir);
        id[j] := cik_tagad_ir;
        ida[cik_tagad_ir] := s_id[j];
        with koord_ir do
         begin
          maska := maska shl 1;
          if maska=0
           then
            begin
             maska := 1;
             Inc(longs);
            end;
          for i:=1 to max_lo do
           if i=longs then a[id[j]][i]:=maska else a[id[j]][i] := 0;
         end;
        koordmas[id[j]] := koord_ir;
       end;

     END;

     {Atliek prbaudt zmi}
     if zime='<'
      then
       begin
        i1 := id[2];
        i2 := id[1];
       end
      else
       begin
        i1 := id[1];
        i2 := id[2];
       end;

      if zime='='
       then flag := true
       else flag := false;

  end; {Ielasi_rindu}

 procedure OR_Lielais(i1,i2 :integer);
 var i: integer;
  begin
   if i1<>i2 then for i:=1 to max_lo do a[i1][i] := a[i1][i] or a[i2][i];
  end; {OR_Lielais}

begin
 cik_tagad_ir := 0;
 with koord_ir do
  begin
   longs := 0;
   maska := 0;
  end;

 Assign(f_in,'AGE.DAT');
 Reset(f_in);

 Readln(f_in,n); {Ielasa rindu skaitu}

 for nn := 1 to n do
  BEGIN

   { Ielasa krtjo rindu }
   Ielasi_rindu(ind1,ind2,flag); { Izpilds ind1>ind2 (flag=false), vai ind1=ind2 (flag=true) }

   if ind1<>ind2
    then
     begin
      { ind1>ind2 }
      { Papildina ind1 rindu ar ind2 : Tie, kas bija jaunki par ind2, ir jaunki ar par ind1 }
      OR_Lielais(ind1,ind2);
      { Tagad jprma visi tie, kas vecki par ind1 - tie ir vecki par tiem, kas jaunki par ind1 }
      for i:=1 to cik_tagad_ir do
        if (a[i][koordmas[ind1].longs] and koordmas[ind1].maska) <> 0 {Ttad vecks par ind1}
         then OR_Lielais(i,ind1);

      if flag
       then  { Gandrz visu jatkrto pretj virzien }
        begin
         OR_Lielais(ind2,ind1);
         { Tagad jprma visi tie, kas vecki par ind2 - tie ir vecki par tiem, kas jaunki par ind2 }
         for i:=1 to cik_tagad_ir do
          if (a[i][koordmas[ind2].longs] and koordmas[ind2].maska) <> 0 {Ttad vecks par ind1}
            then OR_Lielais(i,ind2);
        end;

     end; {ind1<>ind2}

   END; {Viss ielasts}

  Close(f_in);

   {Tagad esam gatavi atbildt uz jautjumiem}

  Assign(f_in,'AGE.ASK');
  Reset(f_in);
  Readln(f_in,n); {Ielasa "jautjumu" skaitu}

  Assign(f_rez,'AGE.REZ');
  Rewrite(f_rez);

  for nn:=1 to n do
   begin
    Ielasi_rindu(ind1,ind2,flag);
    {eit flagam nebs nozmes, jo "darbbas zme" visu laiku ir '?'}

    {Skatamies, ko atbildt}
    pazime := 0;

    {Vai vartu bt, ka ind1>=ind2}
    if (a[ind1][koordmas[ind2].longs] and koordmas[ind2].maska) <> 0 {Ttad ir}
     then Inc(pazime);

     {Vai vartu bt, ka ind2>=ind1}
    if (a[ind2][koordmas[ind1].longs] and koordmas[ind1].maska) <> 0 {Ttad ir}
     then Inc(pazime,2);

     {Skaidrs, ko teikt}
    writeln(f_rez,ida[ind1],zime[pazime],ida[ind2]);

   end;

  Close(f_in);
  Close(f_rez);

end.