uses {$IFDEF Windows} WinCrt {$ELSE} Crt {$ENDIF} ;

var T:array[1..20,1..20] of real;
    n:integer;

procedure ReadInput;
var filename:string;
    i,j:integer;
begin
     Write('Input file name: '); ReadLn(filename);
     Assign(input,filename); Reset(input);
     ReadLn(n);
     for i:=1 to n do
         for j:=1 to n do Read(T[i,j]);
     Close(input);
     for i:=1 to n do T[i,i]:=1;
     for i:=1 to n do
         for j:=1 to n do
             if T[i,j]<>0 then T[j,i]:=1/T[i,j];
end;

procedure Compute;
var Free:array[1..20] of boolean;
    Rinda:array[1..20] of integer;
    i,j,k,q,First,Last:integer;
begin
     for i:=1 to n do Free[i]:=True;
     for i:=1 to n do
         if Free[i] then
            begin
                 First:=1; Last:=1; Rinda[1]:=i; Free[i]:=False;
                 while First<=Last do
                       begin
                            j:=Rinda[First]; Inc(First);
                            for k:=1 to n do
                                if Free[k] and (T[j,k]<>0) then
                                   begin
                                        for q:=1 to Last do
                                            begin
                                                 T[Rinda[q],k]:=T[Rinda[q],j]*T[j,k];
                                                 T[k,Rinda[q]]:=1/T[Rinda[q],k];
                                            end;
                                        Inc(Last); Rinda[Last]:=k;
                                        Free[k]:=False;
                                   end;
                       end;
            end;
end;

procedure WriteOutput;
var i,j:integer;
begin
     Assign(output,'output.txt'); Rewrite(output);
     for i:=1 to n do
         begin
              for j:=1 to n do Write(T[i,j]:0:2,' ');
              WriteLn;
         end;
     Close(output);
end;

begin
     ReadInput;
     Compute;
     WriteOutput;
end.