type Rinda =  record
                   Num:longint; { rindas numurs }
                   Tips:boolean; { True, ja RETURN rinda;
                                   False, ja IF rinda }
                   c1,c2:char; { rindas maini'gie; je'ga tikai tad, kad
                                 Tips=False }
                   T,E:longint; { rindu numuri, uz kuriem ja'pa'riet, ja
                                  attieci'gi c1=c2 un c1<>c2;
                                  je'ga tikai tad, kad Tips=False }
                   Ret:longint; { atgriez'ama' ve'rti'ba; Ret ir je'ga tikai
                                  tad, kad Tips=True }
             end;
     SetType = set of char;

var R:array[1..20] of Rinda;
    Vien:array['a'..'z',1..20] of char;
    Count:array['a'..'z'] of integer;
    NeVien:array['a'..'z'] of SetType;
    Free:array[1..20] of boolean;
    Bija:array[1..21] of longint; { satur visus li'dz s'im atrastos
                                    apaks'programmas rezulta'tus }
    Take:array['a'..'z'] of boolean; {Take[c]=True,ja ievada' ir maini'gais c}
    n,SolC:integer; { n - rindu skaits, SolC - atrasto apaks'programmas
                      rezulta'tu skaits }
    A,B,PalKopa:SetType;
    Q:array[1..26] of char;

procedure ReadInput;
var ch:char; s:string; Code:integer; filename:string;
begin
     FillChar(Take,SizeOf(Take),False);
     Write('Input filename: '); ReadLn(filename);
     Assign(input,filename); Reset(input);
     n:=0;
     while not Eof(input) do
           begin
                Inc(n);
                with R[n] do
                     begin
                          Read(Num,ch,ch);
                          if ch='I' then
                             begin
                                  Tips:=False;
                                  ReadLn(ch,ch,c1,ch,c2,ch,ch,ch,ch,ch,ch,T,ch,ch,ch,ch,ch,ch,E);
                                  Take[c1]:=True; Take[c2]:=True;
                             end
                          else begin
                                    Tips:=True;
                                    ReadLn(s); Dec(s[0]); Delete(S,1,6);
                                    Val(S,Ret,Code);
                               end;
                end;
           end;
     Close(input);
end;

procedure GetNumbers;
var i,j:integer;
begin
     for i:=1 to n do
         if not R[i].Tips then
            begin
                 for j:=1 to n do
                     if R[j].Num=R[i].T then
                        begin R[i].T:=j; Break; end;
                 for j:=1 to n do
                     if R[j].Num=R[i].E then
                        begin R[i].E:=j; Break; end;
            end;
end;

function JauBija(t:longint):boolean;
var i:integer;
begin
     for i:=1 to SolC do
         if Bija[i]=t then begin JauBija:=True; Exit; end;
     JauBija:=False;
     Inc(SolC); Bija[SolC]:=t;
end;

procedure MakeA(c:char);
var First,Last:integer; ch:char; i:integer;
begin
     A:=[c]; First:=1; Last:=1; Q[1]:=c;
     while First<=Last do
           begin
                ch:=Q[First]; Inc(First);
                for i:=1 to Count[ch] do
                    if not (Vien[ch,i] in A) then
                       begin
                            Include(A,Vien[ch,i]);
                            Inc(Last); Q[Last]:=Vien[ch,i];
                       end;
           end;
end;

procedure MakeB(c:char);
var First,Last:integer; ch:char; i:integer;
begin
     B:=NeVien[c]; First:=1; Last:=1; Q[1]:=c;
     PalKopa:=[c];
     while First<=Last do
           begin
                ch:=Q[First]; Inc(First);
                for i:=1 to Count[ch] do
                    if not (Vien[ch,i] in PalKopa) then
                       begin
                            Include(PalKopa,Vien[ch,i]);
                            B:=B+NeVien[Vien[ch,i]];
                            Inc(Last); Q[Last]:=Vien[ch,i];
                       end;
           end;
end;

procedure Druka;
var ch,ch1:char; k:integer; Vert:array['a'..'z'] of integer;
    First:boolean;
begin
     k:=0; FillChar(Vert,SizeOf(Vert),0);
     for ch:='a' to 'z' do
         if Take[ch] and (Vert[ch]=0) then
            begin
                 Inc(k); MakeA(ch);
                 for ch1:='a' to 'z' do
                     if ch1 in A then Vert[ch1]:=k;
            end;
     First:=True;
     for ch:='a' to 'z' do
         if Take[ch] then
            if First then begin Write(ch,'=',Vert[ch]); First:=False; end
            else Write(', ',ch,'=',Vert[ch]);
     WriteLn;
end;

procedure Rekur(k:integer);
var ch,ch1,ch2,temp:char;
begin
     with R[k] do
          begin
               if Tips then
                  begin
                       if not JauBija(Ret) then
                          begin WriteLn(Ret,':'); Druka; end;
                       Exit;
                  end;
               if not Free[k] then
                  begin
                       { iesta'jies cikls, cikla nosaci'ta' ve'rti'ba ir
                         MaxLongInt }
                       if not JauBija(MaxLongInt) then
                          begin WriteLn('Infinite loop:'); Druka; end;
                       Exit;
                  end;
               Free[k]:=False; { atzi'me', ka rinda k jau ir izpildi'ta }
               MakeA(c1); { kopa A satur visus maini'gos, kas viena'di ar c1 }
               if c2 in A then Rekur(T)
               else begin
                         MakeB(c2); { kopa  B satur visus maini'gos, kas  ar
                                      c2 ir daz'a'di }
                         { ja A un B s'k'e'lums nav tuks'a kopa, tad c1 un c2
                           ir daz'a'di }
                         if A*B<>[] then Rekur(E)
                         else begin
                                   { pien'em, ka c1 un c2 ir viena'di }
                                   Inc(Count[c1]);
                                   Vien[c1,Count[c1]]:=c2;
                                   Inc(Count[c2]);
                                   Vien[c2,Count[c2]]:=c1;
                                   Rekur(T);
                                   Dec(Count[c1]); Dec(Count[c2]);
                                   { pien'em, ka c1 un c2 ir daz'a'di }
                                   Include(NeVien[c1],c2);
                                   Include(NeVien[c2],c1);
                                   Rekur(E);
                                   Exclude(NeVien[c1],c2);
                                   Exclude(NeVien[c2],c1);
                              end;
                    end;
               Free[k]:=True; { atzi'me', ka rinda k ve'l nav izpildi'ta }
          end;
end;

procedure Compute;
var ch:char;
begin
     Assign(output,'output.txt'); Rewrite(output);
     FillChar(Count,SizeOf(Count),0); FillChar(Free,SizeOf(Free),True);
     for ch:='a' to 'z' do NeVien[ch]:=[];
     SolC:=0;
     Rekur(1);
     Close(output);
end;

begin
     ReadInput;
     GetNumbers;
     Compute;
end.