type Kambaris = record Rt,Lt,Rc,Lc:integer; end;
     Eja = record x,paz:integer; end;

var Kam:array[1..500] of Kambaris;
    Tree:array[1..500] of integer;
    BestSol,Sol:array[1..500] of integer;
    E:array[1..500,1..3] of Eja;
    Free:array[1..500] of boolean;
    n,k,T,Count:integer;

procedure ReadInput;
var i,j,a,b,c:integer;
begin
     Assign(input,'cav.in'); Reset(input);
     ReadLn(n,k);
     for i:=1 to 3*n div 2 do
         begin
              ReadLn(a,b,c);
              for j:=3 downto 2 do begin E[a,j]:=E[a,j-1]; E[b,j]:=E[b,j-1]; end;
              E[a,1].x:=b; E[a,1].paz:=c;
              E[b,1].x:=a; E[b,1].paz:=c;
         end;
     Close(input);
end;

procedure MakeOutSide;
var i,j,t:integer;
begin
     FillChar(Free,SizeOf(Free),True); Free[1]:=False;
     if E[1,1].x<=k then t:=E[1,1].x else t:=E[1,2].x;
     for i:=1 to k-1 do
         begin
              Tree[i]:=t;
              with Kam[t] do begin Rc:=t; Lc:=t; Rt:=0; Lt:=0; end;
              Free[t]:=False;
              for j:=1 to 3 do
                  if (E[t,j].x<=k) and Free[E[t,j].x]
                  then begin t:=E[t,j].x; Break; end;
         end;
end;

function IsCommonParent(a,b:integer):integer;
var i,j:integer;
begin
     IsCommonParent:=0;
     for i:=1 to 3 do
         for j:=1 to 3 do
             if (E[a,i].x=E[b,j].x) and Free[E[a,i].x]
             then begin IsCommonParent:=E[a,i].x; Exit; end;
end;

procedure MakeTree;
var C,i,j,q:integer;
begin
     MakeOutSide;
     FillChar(Free,SizeOf(Free),True);
     C:=k-1;
     while C>1 do
           begin
                i:=1;
                while i<=C-1 do
                      begin
                           q:=IsCommonParent(Tree[i],Tree[i+1]);
                           if q<>0
                           then begin
                                     Free[Tree[i]]:=False;
                                     Free[Tree[i+1]]:=False;
                                     with Kam[q] do
                                          begin
                                               Lt:=Tree[i]; Rt:=Tree[i+1];
                                               Lc:=Kam[Tree[i]].Lc;
                                               Rc:=Kam[Tree[i+1]].Rc;
                                          end;
                                     Tree[i]:=q;
                                     for j:=i+1 to C-1 do Tree[j]:=Tree[j+1];
                                     Dec(C);
                                end
                           else Inc(i);
                      end;
           end;
     T:=Tree[1];
end;

function TopLeft(i:integer):integer; forward;
function LeftTop(i:integer):integer; forward;
function TopRight(i:integer):integer; forward;
function RightTop(i:integer):integer; forward;
function RightLeft(i:integer):integer; forward;
function LeftRight(i:integer):integer; forward;

function Cost(a,b:integer):integer;
var i:integer;
begin
     for i:=1 to 3 do if E[a,i].x=b then begin Cost:=E[a,i].paz; Exit; end;
end;

function TopLeft(i:integer):integer;
var ret:integer;
begin
     Inc(Count); Sol[Count]:=i;
     ret:=0;
     if Kam[i].Rt<>0
     then begin
               Inc(ret,Cost(i,Kam[i].Rt));
               Inc(ret,TopLeft(Kam[i].Rt));
               Inc(ret,Cost(Kam[Kam[i].Rt].Lc,Kam[Kam[i].Lt].Rc));
               Inc(ret,RightLeft(Kam[i].Lt));
          end;
     TopLeft:=ret;
end;

function LeftTop(i:integer):integer;
var ret:integer;
begin
     ret:=0;
     if Kam[i].Rt<>0
     then begin
               Inc(ret,LeftRight(Kam[i].Lt));
               Inc(ret,Cost(Kam[Kam[i].Rt].Lc,Kam[Kam[i].Lt].Rc));
               Inc(ret,LeftTop(Kam[i].Rt));
               Inc(ret,Cost(i,Kam[i].Rt));
          end;
     Inc(Count); Sol[Count]:=i;
     LeftTop:=ret;
end;

function TopRight(i:integer):integer;
var ret:integer;
begin
     Inc(Count); Sol[Count]:=i;
     ret:=0;
     if Kam[i].Rt<>0
     then begin
               Inc(ret,Cost(i,Kam[i].Lt));
               Inc(ret,TopRight(Kam[i].Lt));
               Inc(ret,Cost(Kam[Kam[i].Rt].Lc,Kam[Kam[i].Lt].Rc));
               Inc(ret,LeftRight(Kam[i].Rt));
          end;
     TopRight:=ret;
end;

function RightTop(i:integer):integer;
var ret:integer;
begin
     ret:=0;
     if Kam[i].Rt<>0
     then begin
               Inc(ret,RightLeft(Kam[i].Rt));
               Inc(ret,Cost(Kam[Kam[i].Rt].Lc,Kam[Kam[i].Lt].Rc));
               Inc(ret,RightTop(Kam[i].Lt));
               Inc(ret,Cost(i,Kam[i].Lt));
          end;
     Inc(Count); Sol[Count]:=i;
     RightTop:=ret;
end;

function RightLeft(i:integer):integer;
var ret:integer;
begin
     ret:=0;
     if Kam[i].Rt<>0
     then begin
               Inc(ret,RightTop(Kam[i].Rt));
               Inc(ret,Cost(i,Kam[i].Rt));
          end;
     Inc(Count); Sol[Count]:=i;
     if Kam[i].Lt<>0
     then begin
               Inc(ret,Cost(i,Kam[i].Lt));
               Inc(ret,TopLeft(Kam[i].Lt));
          end;
     RightLeft:=ret;
end;

function LeftRight(i:integer):integer;
var ret:integer;
begin
     ret:=0;
     if Kam[i].Lt<>0
     then begin
               Inc(ret,LeftTop(Kam[i].Lt));
               Inc(ret,Cost(i,Kam[i].Lt));
          end;
     Inc(Count); Sol[Count]:=i;
     if Kam[i].Rt<>0
     then begin
               Inc(ret,Cost(i,Kam[i].Rt));
               Inc(ret,TopRight(Kam[i].Rt));
          end;
     LeftRight:=ret;
end;

procedure Compute;
var c,Best:integer;
begin
     Sol[1]:=1;
     Count:=1; c:=Cost(1,T)+TopLeft(T)+Cost(1,Kam[T].Lc);
     Best:=c; BestSol:=Sol;
     Count:=1; c:=Cost(1,T)+TopRight(T)+Cost(1,Kam[T].Rc);
     if c<Best then begin Best:=c; BestSol:=Sol; end;
     Count:=1; c:=Cost(1,Kam[T].Rc)+RightLeft(T)+Cost(1,Kam[T].Lc);
     if c<Best then begin Best:=c; BestSol:=Sol; end;
end;

procedure WriteOutput;
var i:integer;
begin
     Assign(output,'cav.out'); Rewrite(output);
     for i:=1 to n do Write(BestSol[i],' '); WriteLn;
     Close(output);
end;

begin
     ReadInput;
     MakeTree;
     Compute;
     WriteOutput;
end.